/* Easy Machine: utility. */

#include <config.h>

#include <xalloc.h>

#include <stdio.h>
#include <string.h>
#include <stdbool.h>

#include <easy-machine/easy-machine.h>
#include <easy-machine/easy-machine-utility.h>


/* Embedding C code into literal strings.
 * ************************************************************************** */

char *
easy_machine_string_clone (const char *s)
{
  size_t length = strlen (s);
  char *res = xmalloc (length + 1);
  strcpy (res, s);
  return res;
}




/* Number parsing
 * ************************************************************************** */

long long
easy_machine_scan_literal (const char *original_s)
{
  const char *s;
  size_t length = strlen (original_s);
  unsigned radix;
  if (length == 0)
    easy_machine_fatal ("ill-formed number %s", original_s);
  else if (length == 1)
    {
      radix = 10;
      s = original_s;
    }
  else if (original_s [0] == '0')
    switch (original_s [1])
      {
      case 'b':
        radix = 2;
        s = original_s + 2;
        break;
      case 'x':
        radix = 16;
        s = original_s + 2;
        break;
      case 'o':
        radix = 8;
        s = original_s + 2;
        break;
      case '0': case '1': case '2': case '3': case '4': case '5': case '6': case '7':
        radix = 8;
        s = original_s + 1;
        break;
      default:
        easy_machine_fatal ("ill-formed radix in number %s", original_s);
      }
  else
    {
      radix = 10;
      s = original_s;
    }
  char *end;
  long long res = strtoll (s, & end, radix);
  if (* end != '\0')
    easy_machine_fatal ("ill-formed radix-%u number %s", radix, original_s);
  else
    return res;
}
